Public IP Addresses - Get

Gets the specified public IP address in a specified resource group.

GET https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/publicIPAddresses/{publicIpAddressName}?api-version=2025-05-01
GET https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/publicIPAddresses/{publicIpAddressName}?api-version=2025-05-01&$expand={$expand}

URI Parameters

Name In Required Type Description
publicIpAddressName
path True

string

The name of the public IP address.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

$expand
query

string

Expands referenced resources.

Responses

Name Type Description
200 OK

Common.PublicIPAddress

Azure operation completed successfully.

Other Status Codes

Common.CloudError

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Get public IP address
Get public IP address with StandardV2 sku

Get public IP address

Sample request

GET https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/testDNS-ip?api-version=2025-05-01

Sample response

{
  "name": "testDNS-ip",
  "type": "Microsoft.Network/publicIPAddresses",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/testDNS-ip",
  "location": "westus",
  "properties": {
    "ddosSettings": {
      "ddosProtectionPlan": {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/ddosProtectionPlans/test-plan"
      },
      "protectionMode": "Enabled"
    },
    "idleTimeoutInMinutes": 4,
    "ipConfiguration": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkInterfaces/testDNS649/ipConfigurations/ipconfig1"
    },
    "ipTags": [
      {
        "ipTagType": "FirstPartyUsage",
        "tag": "SQL"
      },
      {
        "ipTagType": "FirstPartyUsage",
        "tag": "Storage"
      }
    ],
    "provisioningState": "Succeeded",
    "publicIPAddressVersion": "IPv4",
    "publicIPAllocationMethod": "Dynamic"
  }
}

Get public IP address with StandardV2 sku

Sample request

GET https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/testDNS-ip?api-version=2025-05-01

Sample response

{
  "name": "testDNS-ip",
  "type": "Microsoft.Network/publicIPAddresses",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/testDNS-ip",
  "location": "westus",
  "properties": {
    "ddosSettings": {
      "ddosProtectionPlan": {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/ddosProtectionPlans/test-plan"
      },
      "protectionMode": "Enabled"
    },
    "idleTimeoutInMinutes": 4,
    "ipConfiguration": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkInterfaces/testDNS649/ipConfigurations/ipconfig1"
    },
    "ipTags": [
      {
        "ipTagType": "FirstPartyUsage",
        "tag": "SQL"
      },
      {
        "ipTagType": "FirstPartyUsage",
        "tag": "Storage"
      }
    ],
    "provisioningState": "Succeeded",
    "publicIPAddressVersion": "IPv4",
    "publicIPAllocationMethod": "Dynamic"
  },
  "sku": {
    "name": "StandardV2"
  }
}

Definitions

Name Description
AccessMode

The access mode of the private link service.

Common.ApplicationGatewayBackendAddress

Backend address of an application gateway.

Common.ApplicationGatewayBackendAddressPool

Backend Address Pool of an application gateway.

Common.ApplicationGatewayIPConfiguration

IP configuration of an application gateway. Currently 1 public and 1 private IP configuration is allowed.

Common.ApplicationSecurityGroup

An application security group in a resource group.

Common.BackendAddressPool

Pool of backend IP addresses.

Common.CloudError

An error response from the service.

Common.CloudErrorBody

An error response from the service.

Common.CustomDnsConfigPropertiesFormat

Contains custom Dns resolution configuration from customer.

Common.DdosSettings

Contains the DDoS protection settings of the public IP.

Common.Delegation

Details the service to which the subnet is delegated.

Common.ExtendedLocation

ExtendedLocation complex type.

Common.FlowLog

A flow log resource.

Common.FlowLogFormatParameters

Parameters that define the flow log format.

Common.FrontendIPConfiguration

Frontend IP address of the load balancer.

Common.GatewayLoadBalancerTunnelInterface

Gateway load balancer tunnel interface of a load balancer backend address pool.

Common.InboundNatRule

Inbound NAT rule of the load balancer.

Common.IpamPoolPrefixAllocation

IpamPool prefix allocation reference.

Common.IPConfiguration

IP configuration.

Common.IPConfigurationProfile

IP configuration profile child resource.

Common.IpTag

Contains the IpTag associated with the object.

Common.LoadBalancerBackendAddress

Load balancer backend addresses.

Common.ManagedServiceIdentity

Identity for the resource.

Common.NatGateway

Nat Gateway resource.

Common.NatGatewaySku

SKU of nat gateway.

Common.NatRulePortMapping

Individual port mappings for inbound NAT rule created for backend pool.

Common.NetworkInterface

A network interface in a resource group.

Common.NetworkInterfaceDnsSettings

DNS settings of a network interface.

Common.NetworkInterfaceIPConfiguration

IPConfiguration in a network interface.

Common.NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties

PrivateLinkConnection properties for the network interface.

Common.NetworkInterfaceTapConfiguration

Tap configuration in a Network Interface.

Common.NetworkSecurityGroup

NetworkSecurityGroup resource.

Common.PrivateEndpoint

Private endpoint resource.

Common.PrivateEndpointConnection

PrivateEndpointConnection resource.

Common.PrivateEndpointIPConfiguration

An IP Configuration of the private endpoint.

Common.PrivateLinkService

Private link service resource.

Common.PrivateLinkServiceConnection

PrivateLinkServiceConnection resource.

Common.PrivateLinkServiceConnectionState

A collection of information about the state of the connection between service consumer and provider.

Common.PrivateLinkServiceIpConfiguration

The private link service ip configuration.

Common.PrivateLinkServicePropertiesAutoApproval

The auto-approval list of the private link service.

Common.PrivateLinkServicePropertiesVisibility

The visibility list of the private link service.

Common.PublicIPAddress

Public IP address resource.

Common.PublicIPAddressDnsSettings

Contains FQDN of the DNS record associated with the public IP address.

Common.PublicIPAddressSku

SKU of a public IP address.

Common.ResourceNavigationLink

ResourceNavigationLink resource.

Common.RetentionPolicyParameters

Parameters that define the retention policy for flow log.

Common.Route

Route resource.

Common.RouteTable

Route table resource.

Common.SecurityRule

Network security rule.

Common.ServiceAssociationLink

ServiceAssociationLink resource.

Common.ServiceEndpointPolicy

Service End point policy resource.

Common.ServiceEndpointPolicyDefinition

Service Endpoint policy definitions.

Common.ServiceEndpointPropertiesFormat

The service endpoint properties.

Common.Subnet

Subnet in a virtual network resource.

Common.SubResource

Reference to another subresource.

Common.TrafficAnalyticsConfigurationProperties

Parameters that define the configuration of traffic analytics.

Common.TrafficAnalyticsProperties

Parameters that define the configuration of traffic analytics.

Common.VirtualNetworkTap

Virtual Network Tap resource.

DdosSettingsProtectionMode

The DDoS protection mode of the public IP

DeleteOptions

Specify what happens to the public IP address when the VM using it is deleted

ExtendedLocationTypes

The type of the extended location.

FlowLogFormatType

The file type of flow log.

GatewayLoadBalancerTunnelInterfaceType

Traffic type of gateway load balancer tunnel interface.

GatewayLoadBalancerTunnelProtocol

Protocol of gateway load balancer tunnel interface.

IPAllocationMethod

Private IP allocation method.

IPVersion

Whether the specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4.

LoadBalancerBackendAddressAdminState

A list of administrative states which once set can override health probe so that Load Balancer will always forward new connections to backend, or deny new connections and reset existing connections.

ManagedServiceIdentityUserAssignedIdentities
NatGatewaySkuName

Name of Nat Gateway SKU.

NetworkInterfaceAuxiliaryMode

Auxiliary mode of Network Interface resource.

NetworkInterfaceAuxiliarySku

Auxiliary sku of Network Interface resource.

NetworkInterfaceMigrationPhase

Migration phase of Network Interface resource.

NetworkInterfaceNicType

Type of Network Interface resource.

PrivateEndpointIPVersionType

Specifies the IP version type for the private IPs of the private endpoint. If not defined, this defaults to IPv4.

ProvisioningState

The provisioning state of the application security group resource.

PublicIpAddressDnsSettingsDomainNameLabelScope

The domain name label scope. If a domain name label and a domain name label scope are specified, an A DNS record is created for the public IP in the Microsoft Azure DNS system with a hashed value includes in FQDN.

PublicIPAddressMigrationPhase

Migration phase of Public IP Address.

PublicIPAddressSkuName

Name of a public IP address SKU.

PublicIPAddressSkuTier

Tier of a public IP address SKU.

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the virtual machine.

RouteNextHopType

The type of Azure hop the packet should be sent to.

SecurityRuleAccess

The network traffic is allowed or denied.

SecurityRuleDirection

The direction of the rule. The direction specifies if rule will be evaluated on incoming or outgoing traffic.

SecurityRuleProtocol

Network protocol this rule applies to.

SharingScope

Set this property to Tenant to allow sharing subnet with other subscriptions in your AAD tenant. This property can only be set if defaultOutboundAccess is set to false, both properties can only be set if subnet is empty.

SyncMode

Backend address synchronous mode for the backend pool

TransportProtocol

The reference to the transport protocol used by the load balancing rule.

VirtualNetworkPrivateEndpointNetworkPolicies

Enable or Disable apply network policies on private end point in the subnet.

VirtualNetworkPrivateLinkServiceNetworkPolicies

Enable or Disable apply network policies on private link service in the subnet.

AccessMode

The access mode of the private link service.

Value Description
Default

Allows unrestricted access to the private link service.

Restricted

Limits access to subscriptions which are inside visibility list only.

Common.ApplicationGatewayBackendAddress

Backend address of an application gateway.

Name Type Description
fqdn

string

Fully qualified domain name (FQDN).

ipAddress

string

IP address.

Common.ApplicationGatewayBackendAddressPool

Backend Address Pool of an application gateway.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the backend address pool that is unique within an Application Gateway.

properties.backendAddresses

Common.ApplicationGatewayBackendAddress[]

Backend addresses.

properties.backendIPConfigurations

Common.NetworkInterfaceIPConfiguration[]

Collection of references to IPs defined in network interfaces.

properties.provisioningState

ProvisioningState

The provisioning state of the backend address pool resource.

type

string

Type of the resource.

Common.ApplicationGatewayIPConfiguration

IP configuration of an application gateway. Currently 1 public and 1 private IP configuration is allowed.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the IP configuration that is unique within an Application Gateway.

properties.provisioningState

ProvisioningState

The provisioning state of the application gateway IP configuration resource.

properties.subnet

Common.SubResource

Reference to the subnet resource. A subnet from where application gateway gets its private address.

type

string

Type of the resource.

Common.ApplicationSecurityGroup

An application security group in a resource group.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.provisioningState

ProvisioningState

The provisioning state of the application security group resource.

properties.resourceGuid

string

The resource GUID property of the application security group resource. It uniquely identifies a resource, even if the user changes its name or migrate the resource across subscriptions or resource groups.

tags

object

Resource tags.

type

string

Resource type.

Common.BackendAddressPool

Pool of backend IP addresses.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.backendIPConfigurations

Common.NetworkInterfaceIPConfiguration[]

An array of references to IP addresses defined in network interfaces.

properties.drainPeriodInSeconds

integer (int32)

Amount of seconds Load Balancer waits for before sending RESET to client and backend address.

properties.inboundNatRules

Common.SubResource[]

An array of references to inbound NAT rules that use this backend address pool.

properties.loadBalancerBackendAddresses

Common.LoadBalancerBackendAddress[]

An array of backend addresses.

properties.loadBalancingRules

Common.SubResource[]

An array of references to load balancing rules that use this backend address pool.

properties.location

string

The location of the backend address pool.

properties.outboundRule

Common.SubResource

A reference to an outbound rule that uses this backend address pool.

properties.outboundRules

Common.SubResource[]

An array of references to outbound rules that use this backend address pool.

properties.provisioningState

ProvisioningState

The provisioning state of the backend address pool resource.

properties.syncMode

SyncMode

Backend address synchronous mode for the backend pool

properties.tunnelInterfaces

Common.GatewayLoadBalancerTunnelInterface[]

An array of gateway load balancer tunnel interfaces.

properties.virtualNetwork

Common.SubResource

A reference to a virtual network.

type

string

Resource type.

Common.CloudError

An error response from the service.

Name Type Description
error

Common.CloudErrorBody

Cloud error body.

Common.CloudErrorBody

An error response from the service.

Name Type Description
code

string

An identifier for the error. Codes are invariant and are intended to be consumed programmatically.

details

Common.CloudErrorBody[]

A list of additional details about the error.

message

string

A message describing the error, intended to be suitable for display in a user interface.

target

string

The target of the particular error. For example, the name of the property in error.

Common.CustomDnsConfigPropertiesFormat

Contains custom Dns resolution configuration from customer.

Name Type Description
fqdn

string

Fqdn that resolves to private endpoint ip address.

ipAddresses

string[]

A list of private ip addresses of the private endpoint.

Common.DdosSettings

Contains the DDoS protection settings of the public IP.

Name Type Description
ddosProtectionPlan

Common.SubResource

The DDoS protection plan associated with the public IP. Can only be set if ProtectionMode is Enabled

protectionMode

DdosSettingsProtectionMode

The DDoS protection mode of the public IP

Common.Delegation

Details the service to which the subnet is delegated.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

The name of the resource that is unique within a subnet. This name can be used to access the resource.

properties.actions

string[]

The actions permitted to the service upon delegation.

properties.provisioningState

ProvisioningState

The provisioning state of the service delegation resource.

properties.serviceName

string

The name of the service to whom the subnet should be delegated (e.g. Microsoft.Sql/servers).

type

string

Resource type.

Common.ExtendedLocation

ExtendedLocation complex type.

Name Type Description
name

string

The name of the extended location.

type

ExtendedLocationTypes

The type of the extended location.

Common.FlowLog

A flow log resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

identity

Common.ManagedServiceIdentity

FlowLog resource Managed Identity

location

string

Resource location.

name

string

Resource name.

properties.enabled

boolean

Flag to enable/disable flow logging.

properties.enabledFilteringCriteria

string

Optional field to filter network traffic logs based on SrcIP, SrcPort, DstIP, DstPort, Protocol, Encryption, Direction and Action. If not specified, all network traffic will be logged.

properties.flowAnalyticsConfiguration

Common.TrafficAnalyticsProperties

Parameters that define the configuration of traffic analytics.

properties.format

Common.FlowLogFormatParameters

Parameters that define the flow log format.

properties.provisioningState

ProvisioningState

The provisioning state of the flow log.

properties.recordTypes

string

Optional field to filter network traffic logs based on flow states. Value of this field could be any comma separated combination string of letters B,C,E or D. B represents Begin, when a flow is created. C represents Continue for an ongoing flow generated at every five-minute interval. E represents End, when a flow is terminated. D represents Deny, when a flow is denied. If not specified, all network traffic will be logged.

properties.retentionPolicy

Common.RetentionPolicyParameters

Parameters that define the retention policy for flow log.

properties.storageId

string

ID of the storage account which is used to store the flow log.

properties.targetResourceGuid

string

Guid of network security group to which flow log will be applied.

properties.targetResourceId

string

ID of network security group to which flow log will be applied.

tags

object

Resource tags.

type

string

Resource type.

Common.FlowLogFormatParameters

Parameters that define the flow log format.

Name Type Default value Description
type

FlowLogFormatType

The file type of flow log.

version

integer (int32)

0

The version (revision) of the flow log.

Common.FrontendIPConfiguration

Frontend IP address of the load balancer.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.gatewayLoadBalancer

Common.SubResource

The reference to gateway load balancer frontend IP.

properties.inboundNatPools

Common.SubResource[]

An array of references to inbound pools that use this frontend IP.

properties.inboundNatRules

Common.SubResource[]

An array of references to inbound rules that use this frontend IP.

properties.loadBalancingRules

Common.SubResource[]

An array of references to load balancing rules that use this frontend IP.

properties.outboundRules

Common.SubResource[]

An array of references to outbound rules that use this frontend IP.

properties.privateIPAddress

string

The private IP address of the IP configuration.

properties.privateIPAddressVersion

IPVersion

Whether the specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4.

properties.privateIPAllocationMethod

IPAllocationMethod

The Private IP allocation method.

properties.provisioningState

ProvisioningState

The provisioning state of the frontend IP configuration resource.

properties.publicIPAddress

Common.PublicIPAddress

The reference to the Public IP resource.

properties.publicIPPrefix

Common.SubResource

The reference to the Public IP Prefix resource.

properties.subnet

Common.Subnet

The reference to the subnet resource.

type

string

Resource type.

zones

string[]

A list of availability zones denoting the IP allocated for the resource needs to come from.

Common.GatewayLoadBalancerTunnelInterface

Gateway load balancer tunnel interface of a load balancer backend address pool.

Name Type Description
identifier

integer (int32)

Identifier of gateway load balancer tunnel interface.

port

integer (int32)

Port of gateway load balancer tunnel interface.

protocol

GatewayLoadBalancerTunnelProtocol

Protocol of gateway load balancer tunnel interface.

type

GatewayLoadBalancerTunnelInterfaceType

Traffic type of gateway load balancer tunnel interface.

Common.InboundNatRule

Inbound NAT rule of the load balancer.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.backendAddressPool

Common.SubResource

A reference to backendAddressPool resource.

properties.backendIPConfiguration

Common.NetworkInterfaceIPConfiguration

A reference to a private IP address defined on a network interface of a VM. Traffic sent to the frontend port of each of the frontend IP configurations is forwarded to the backend IP.

properties.backendPort

integer (int32)

The port used for the internal endpoint. Acceptable values range from 1 to 65535.

properties.enableFloatingIP

boolean

Configures a virtual machine's endpoint for the floating IP capability required to configure a SQL AlwaysOn Availability Group. This setting is required when using the SQL AlwaysOn Availability Groups in SQL server. This setting can't be changed after you create the endpoint.

properties.enableTcpReset

boolean

Receive bidirectional TCP Reset on TCP flow idle timeout or unexpected connection termination. This element is only used when the protocol is set to TCP.

properties.frontendIPConfiguration

Common.SubResource

A reference to frontend IP addresses.

properties.frontendPort

integer (int32)

The port for the external endpoint. Port numbers for each rule must be unique within the Load Balancer. Acceptable values range from 1 to 65534.

properties.frontendPortRangeEnd

integer (int32)

The port range end for the external endpoint. This property is used together with BackendAddressPool and FrontendPortRangeStart. Individual inbound NAT rule port mappings will be created for each backend address from BackendAddressPool. Acceptable values range from 1 to 65534.

properties.frontendPortRangeStart

integer (int32)

The port range start for the external endpoint. This property is used together with BackendAddressPool and FrontendPortRangeEnd. Individual inbound NAT rule port mappings will be created for each backend address from BackendAddressPool. Acceptable values range from 1 to 65534.

properties.idleTimeoutInMinutes

integer (int32)

The timeout for the TCP idle connection. The value can be set between 4 and 30 minutes. The default value is 4 minutes. This element is only used when the protocol is set to TCP.

properties.protocol

TransportProtocol

The reference to the transport protocol used by the load balancing rule.

properties.provisioningState

ProvisioningState

The provisioning state of the inbound NAT rule resource.

type

string

Resource type.

Common.IpamPoolPrefixAllocation

IpamPool prefix allocation reference.

Name Type Description
allocatedAddressPrefixes

string[]

List of assigned IP address prefixes in the IpamPool of the associated resource.

numberOfIpAddresses

string

Number of IP addresses to allocate.

pool.id

string (arm-id)

Resource id of the associated Azure IpamPool resource.

Common.IPConfiguration

IP configuration.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

The name of the resource that is unique within a resource group. This name can be used to access the resource.

properties.privateIPAddress

string

The private IP address of the IP configuration.

properties.privateIPAllocationMethod

IPAllocationMethod

The private IP address allocation method.

properties.provisioningState

ProvisioningState

The provisioning state of the IP configuration resource.

properties.publicIPAddress

Common.PublicIPAddress

The reference to the public IP resource.

properties.subnet

Common.Subnet

The reference to the subnet resource.

Common.IPConfigurationProfile

IP configuration profile child resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

The name of the resource. This name can be used to access the resource.

properties.provisioningState

ProvisioningState

The provisioning state of the IP configuration profile resource.

properties.subnet

Common.Subnet

The reference to the subnet resource to create a container network interface ip configuration.

type

string

Sub Resource type.

Common.IpTag

Contains the IpTag associated with the object.

Name Type Description
ipTagType

string

The IP tag type. Example: FirstPartyUsage.

tag

string

The value of the IP tag associated with the public IP. Example: SQL.

Common.LoadBalancerBackendAddress

Load balancer backend addresses.

Name Type Description
name

string

Name of the backend address.

properties.adminState

LoadBalancerBackendAddressAdminState

A list of administrative states which once set can override health probe so that Load Balancer will always forward new connections to backend, or deny new connections and reset existing connections.

properties.inboundNatRulesPortMapping

Common.NatRulePortMapping[]

Collection of inbound NAT rule port mappings.

properties.ipAddress

string

IP Address belonging to the referenced virtual network.

properties.loadBalancerFrontendIPConfiguration

Common.SubResource

Reference to the frontend ip address configuration defined in regional loadbalancer.

properties.networkInterfaceIPConfiguration

Common.SubResource

Reference to IP address defined in network interfaces.

properties.subnet

Common.SubResource

Reference to an existing subnet.

properties.virtualNetwork

Common.SubResource

Reference to an existing virtual network.

Common.ManagedServiceIdentity

Identity for the resource.

Name Type Description
principalId

string

The principal id of the system assigned identity. This property will only be provided for a system assigned identity.

tenantId

string

The tenant id of the system assigned identity. This property will only be provided for a system assigned identity.

type

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the virtual machine.

userAssignedIdentities

<string,  ManagedServiceIdentityUserAssignedIdentities>

The list of user identities associated with resource. The user identity dictionary key references will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.

Common.NatGateway

Nat Gateway resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.idleTimeoutInMinutes

integer (int32)

The idle timeout of the nat gateway.

properties.provisioningState

ProvisioningState

The provisioning state of the NAT gateway resource.

properties.publicIpAddresses

Common.SubResource[]

An array of public ip addresses V4 associated with the nat gateway resource.

properties.publicIpAddressesV6

Common.SubResource[]

An array of public ip addresses V6 associated with the nat gateway resource.

properties.publicIpPrefixes

Common.SubResource[]

An array of public ip prefixes V4 associated with the nat gateway resource.

properties.publicIpPrefixesV6

Common.SubResource[]

An array of public ip prefixes V6 associated with the nat gateway resource.

properties.resourceGuid

string

The resource GUID property of the NAT gateway resource.

properties.serviceGateway

Common.SubResource

Reference to an existing service gateway.

properties.sourceVirtualNetwork

Common.SubResource

A reference to the source virtual network using this nat gateway resource.

properties.subnets

Common.SubResource[]

An array of references to the subnets using this nat gateway resource.

sku

Common.NatGatewaySku

The nat gateway SKU.

tags

object

Resource tags.

type

string

Resource type.

zones

string[]

A list of availability zones denoting the zone in which Nat Gateway should be deployed.

Common.NatGatewaySku

SKU of nat gateway.

Name Type Description
name

NatGatewaySkuName

Name of Nat Gateway SKU.

Common.NatRulePortMapping

Individual port mappings for inbound NAT rule created for backend pool.

Name Type Description
backendPort

integer (int32)

Backend port.

frontendPort

integer (int32)

Frontend port.

inboundNatRuleName

string

Name of inbound NAT rule.

Common.NetworkInterface

A network interface in a resource group.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

extendedLocation

Common.ExtendedLocation

The extended location of the network interface.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.auxiliaryMode

NetworkInterfaceAuxiliaryMode

Auxiliary mode of Network Interface resource.

properties.auxiliarySku

NetworkInterfaceAuxiliarySku

Auxiliary sku of Network Interface resource.

properties.defaultOutboundConnectivityEnabled

boolean

Whether default outbound connectivity for nic was configured or not.

properties.disableTcpStateTracking

boolean

Indicates whether to disable tcp state tracking.

properties.dnsSettings

Common.NetworkInterfaceDnsSettings

The DNS settings in network interface.

properties.dscpConfiguration

Common.SubResource

A reference to the dscp configuration to which the network interface is linked.

properties.enableAcceleratedNetworking

boolean

If the network interface is configured for accelerated networking. Not applicable to VM sizes which require accelerated networking.

properties.enableIPForwarding

boolean

Indicates whether IP forwarding is enabled on this network interface.

properties.hostedWorkloads

string[]

A list of references to linked BareMetal resources.

properties.ipConfigurations

Common.NetworkInterfaceIPConfiguration[]

A list of IPConfigurations of the network interface.

properties.macAddress

string

The MAC address of the network interface.

properties.migrationPhase

NetworkInterfaceMigrationPhase

Migration phase of Network Interface resource.

properties.networkSecurityGroup

Common.NetworkSecurityGroup

The reference to the NetworkSecurityGroup resource.

properties.nicType

NetworkInterfaceNicType

Type of Network Interface resource.

properties.primary

boolean

Whether this is a primary network interface on a virtual machine.

properties.privateEndpoint

Common.PrivateEndpoint

A reference to the private endpoint to which the network interface is linked.

properties.privateLinkService

Common.PrivateLinkService

Privatelinkservice of the network interface resource.

properties.provisioningState

ProvisioningState

The provisioning state of the network interface resource.

properties.resourceGuid

string

The resource GUID property of the network interface resource.

properties.tapConfigurations

Common.NetworkInterfaceTapConfiguration[]

A list of TapConfigurations of the network interface.

properties.virtualMachine

Common.SubResource

The reference to a virtual machine.

properties.vnetEncryptionSupported

boolean

Whether the virtual machine this nic is attached to supports encryption.

properties.workloadType

string

WorkloadType of the NetworkInterface for BareMetal resources

tags

object

Resource tags.

type

string

Resource type.

Common.NetworkInterfaceDnsSettings

DNS settings of a network interface.

Name Type Description
appliedDnsServers

string[]

If the VM that uses this NIC is part of an Availability Set, then this list will have the union of all DNS servers from all NICs that are part of the Availability Set. This property is what is configured on each of those VMs.

dnsServers

string[]

List of DNS servers IP addresses. Use 'AzureProvidedDNS' to switch to azure provided DNS resolution. 'AzureProvidedDNS' value cannot be combined with other IPs, it must be the only value in dnsServers collection.

internalDnsNameLabel

string

Relative DNS name for this NIC used for internal communications between VMs in the same virtual network.

internalDomainNameSuffix

string

Even if internalDnsNameLabel is not specified, a DNS entry is created for the primary NIC of the VM. This DNS name can be constructed by concatenating the VM name with the value of internalDomainNameSuffix.

internalFqdn

string

Fully qualified DNS name supporting internal communications between VMs in the same virtual network.

Common.NetworkInterfaceIPConfiguration

IPConfiguration in a network interface.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.applicationGatewayBackendAddressPools

Common.ApplicationGatewayBackendAddressPool[]

The reference to ApplicationGatewayBackendAddressPool resource.

properties.applicationSecurityGroups

Common.ApplicationSecurityGroup[]

Application security groups in which the IP configuration is included.

properties.gatewayLoadBalancer

Common.SubResource

The reference to gateway load balancer frontend IP.

properties.loadBalancerBackendAddressPools

Common.BackendAddressPool[]

The reference to LoadBalancerBackendAddressPool resource.

properties.loadBalancerInboundNatRules

Common.InboundNatRule[]

A list of references of LoadBalancerInboundNatRules.

properties.primary

boolean

Whether this is a primary customer address on the network interface.

properties.privateIPAddress

string

Private IP address of the IP configuration. It can be a single IP address or a CIDR block in the format

/<prefix-length>.

properties.privateIPAddressPrefixLength

integer (int32)

minimum: 1
maximum: 128

The private IP address prefix length. If specified and the allocation method is dynamic, the service will allocate a CIDR block instead of a single IP address.

properties.privateIPAddressVersion

IPVersion

Whether the specific IP configuration is IPv4 or IPv6. Default is IPv4.

properties.privateIPAllocationMethod

IPAllocationMethod

The private IP address allocation method.

properties.privateLinkConnectionProperties

Common.NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties

PrivateLinkConnection properties for the network interface.

properties.provisioningState

ProvisioningState

The provisioning state of the network interface IP configuration.

properties.publicIPAddress

Common.PublicIPAddress

Public IP address bound to the IP configuration.

properties.subnet

Common.Subnet

Subnet bound to the IP configuration.

properties.virtualNetworkTaps

Common.VirtualNetworkTap[]

The reference to Virtual Network Taps.

type

string

Resource type.

Common.NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties

PrivateLinkConnection properties for the network interface.

Name Type Description
fqdns

string[]

List of FQDNs for current private link connection.

groupId

string

The group ID for current private link connection.

requiredMemberName

string

The required member name for current private link connection.

Common.NetworkInterfaceTapConfiguration

Tap configuration in a Network Interface.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.provisioningState

ProvisioningState

The provisioning state of the network interface tap configuration resource.

properties.virtualNetworkTap

Common.VirtualNetworkTap

The reference to the Virtual Network Tap resource.

type

string

Resource type.

Common.NetworkSecurityGroup

NetworkSecurityGroup resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.defaultSecurityRules

Common.SecurityRule[]

The default security rules of network security group.

properties.flowLogs

Common.FlowLog[]

A collection of references to flow log resources.

properties.flushConnection

boolean

When enabled, flows created from Network Security Group connections will be re-evaluated when rules are updates. Initial enablement will trigger re-evaluation.

properties.networkInterfaces

Common.NetworkInterface[]

A collection of references to network interfaces.

properties.provisioningState

ProvisioningState

The provisioning state of the network security group resource.

properties.resourceGuid

string

The resource GUID property of the network security group resource.

properties.securityRules

Common.SecurityRule[]

A collection of security rules of the network security group.

properties.subnets

Common.Subnet[]

A collection of references to subnets.

tags

object

Resource tags.

type

string

Resource type.

Common.PrivateEndpoint

Private endpoint resource.

Name Type Default value Description
etag

string

A unique read-only string that changes whenever the resource is updated.

extendedLocation

Common.ExtendedLocation

The extended location of the load balancer.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.applicationSecurityGroups

Common.ApplicationSecurityGroup[]

Application security groups in which the private endpoint IP configuration is included.

properties.customDnsConfigs

Common.CustomDnsConfigPropertiesFormat[]

An array of custom dns configurations.

properties.customNetworkInterfaceName

string

The custom name of the network interface attached to the private endpoint.

properties.ipConfigurations

Common.PrivateEndpointIPConfiguration[]

A list of IP configurations of the private endpoint. This will be used to map to the First Party Service's endpoints.

properties.ipVersionType

PrivateEndpointIPVersionType

IPv4

Specifies the IP version type for the private IPs of the private endpoint. If not defined, this defaults to IPv4.

properties.manualPrivateLinkServiceConnections

Common.PrivateLinkServiceConnection[]

A grouping of information about the connection to the remote resource. Used when the network admin does not have access to approve connections to the remote resource.

properties.networkInterfaces

Common.NetworkInterface[]

An array of references to the network interfaces created for this private endpoint.

properties.privateLinkServiceConnections

Common.PrivateLinkServiceConnection[]

A grouping of information about the connection to the remote resource.

properties.provisioningState

ProvisioningState

The provisioning state of the private endpoint resource.

properties.subnet

Common.Subnet

The ID of the subnet from which the private IP will be allocated.

tags

object

Resource tags.

type

string

Resource type.

Common.PrivateEndpointConnection

PrivateEndpointConnection resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.linkIdentifier

string

The consumer link id.

properties.privateEndpoint

Common.PrivateEndpoint

The resource of private end point.

properties.privateEndpointLocation

string

The location of the private endpoint.

properties.privateLinkServiceConnectionState

Common.PrivateLinkServiceConnectionState

A collection of information about the state of the connection between service consumer and provider.

properties.provisioningState

ProvisioningState

The provisioning state of the private endpoint connection resource.

type

string

Resource type.

Common.PrivateEndpointIPConfiguration

An IP Configuration of the private endpoint.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

name

string

The name of the resource that is unique within a resource group.

properties.groupId

string

The ID of a group obtained from the remote resource that this private endpoint should connect to.

properties.memberName

string

The member name of a group obtained from the remote resource that this private endpoint should connect to.

properties.privateIPAddress

string

A private ip address obtained from the private endpoint's subnet.

type

string

The resource type.

Common.PrivateLinkService

Private link service resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

extendedLocation

Common.ExtendedLocation

The extended location of the load balancer.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.accessMode

AccessMode

The access mode of the private link service.

properties.alias

string

The alias of the private link service.

properties.autoApproval

Common.PrivateLinkServicePropertiesAutoApproval

The auto-approval list of the private link service.

properties.destinationIPAddress

string

The destination IP address of the private link service.

properties.enableProxyProtocol

boolean

Whether the private link service is enabled for proxy protocol or not.

properties.fqdns

string[]

The list of Fqdn.

properties.ipConfigurations

Common.PrivateLinkServiceIpConfiguration[]

An array of private link service IP configurations.

properties.loadBalancerFrontendIpConfigurations

Common.FrontendIPConfiguration[]

An array of references to the load balancer IP configurations.

properties.networkInterfaces

Common.NetworkInterface[]

An array of references to the network interfaces created for this private link service.

properties.privateEndpointConnections

Common.PrivateEndpointConnection[]

An array of list about connections to the private endpoint.

properties.provisioningState

ProvisioningState

The provisioning state of the private link service resource.

properties.visibility

Common.PrivateLinkServicePropertiesVisibility

The visibility list of the private link service.

tags

object

Resource tags.

type

string

Resource type.

Common.PrivateLinkServiceConnection

PrivateLinkServiceConnection resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

The name of the resource that is unique within a resource group. This name can be used to access the resource.

properties.groupIds

string[]

The ID(s) of the group(s) obtained from the remote resource that this private endpoint should connect to.

properties.privateLinkServiceConnectionState

Common.PrivateLinkServiceConnectionState

A collection of read-only information about the state of the connection to the remote resource.

properties.privateLinkServiceId

string

The resource id of private link service.

properties.provisioningState

ProvisioningState

The provisioning state of the private link service connection resource.

properties.requestMessage

string

A message passed to the owner of the remote resource with this connection request. Restricted to 140 chars.

type

string

The resource type.

Common.PrivateLinkServiceConnectionState

A collection of information about the state of the connection between service consumer and provider.

Name Type Description
actionsRequired

string

A message indicating if changes on the service provider require any updates on the consumer.

description

string

The reason for approval/rejection of the connection.

status

string

Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.

Common.PrivateLinkServiceIpConfiguration

The private link service ip configuration.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

The name of private link service ip configuration.

properties.primary

boolean

Whether the ip configuration is primary or not.

properties.privateIPAddress

string

The private IP address of the IP configuration.

properties.privateIPAddressVersion

IPVersion

Whether the specific IP configuration is IPv4 or IPv6. Default is IPv4.

properties.privateIPAllocationMethod

IPAllocationMethod

The private IP address allocation method.

properties.provisioningState

ProvisioningState

The provisioning state of the private link service IP configuration resource.

properties.subnet

Common.Subnet

The reference to the subnet resource.

type

string

The resource type.

Common.PrivateLinkServicePropertiesAutoApproval

The auto-approval list of the private link service.

Name Type Description
subscriptions

string[]

The list of subscriptions.

Common.PrivateLinkServicePropertiesVisibility

The visibility list of the private link service.

Name Type Description
subscriptions

string[]

The list of subscriptions.

Common.PublicIPAddress

Public IP address resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

extendedLocation

Common.ExtendedLocation

The extended location of the public ip address.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.ddosSettings

Common.DdosSettings

The DDoS protection custom policy associated with the public IP address.

properties.deleteOption

DeleteOptions

Specify what happens to the public IP address when the VM using it is deleted

properties.dnsSettings

Common.PublicIPAddressDnsSettings

The FQDN of the DNS record associated with the public IP address.

properties.idleTimeoutInMinutes

integer (int32)

The idle timeout of the public IP address.

properties.ipAddress

string

The IP address associated with the public IP address resource.

properties.ipConfiguration

Common.IPConfiguration

The IP configuration associated with the public IP address.

properties.ipTags

Common.IpTag[]

The list of tags associated with the public IP address.

properties.linkedPublicIPAddress

Common.PublicIPAddress

The linked public IP address of the public IP address resource.

properties.migrationPhase

PublicIPAddressMigrationPhase

Migration phase of Public IP Address.

properties.natGateway

Common.NatGateway

The NatGateway for the Public IP address.

properties.provisioningState

ProvisioningState

The provisioning state of the public IP address resource.

properties.publicIPAddressVersion

IPVersion

The public IP address version.

properties.publicIPAllocationMethod

IPAllocationMethod

The public IP address allocation method.

properties.publicIPPrefix

Common.SubResource

The Public IP Prefix this Public IP Address should be allocated from.

properties.resourceGuid

string

The resource GUID property of the public IP address resource.

properties.servicePublicIPAddress

Common.PublicIPAddress

The service public IP address of the public IP address resource.

sku

Common.PublicIPAddressSku

The public IP address SKU.

tags

object

Resource tags.

type

string

Resource type.

zones

string[]

A list of availability zones denoting the IP allocated for the resource needs to come from.

Common.PublicIPAddressDnsSettings

Contains FQDN of the DNS record associated with the public IP address.

Name Type Description
domainNameLabel

string

The domain name label. The concatenation of the domain name label and the regionalized DNS zone make up the fully qualified domain name associated with the public IP address. If a domain name label is specified, an A DNS record is created for the public IP in the Microsoft Azure DNS system.

domainNameLabelScope

PublicIpAddressDnsSettingsDomainNameLabelScope

The domain name label scope. If a domain name label and a domain name label scope are specified, an A DNS record is created for the public IP in the Microsoft Azure DNS system with a hashed value includes in FQDN.

fqdn

string

The Fully Qualified Domain Name of the A DNS record associated with the public IP. This is the concatenation of the domainNameLabel and the regionalized DNS zone.

reverseFqdn

string

The reverse FQDN. A user-visible, fully qualified domain name that resolves to this public IP address. If the reverseFqdn is specified, then a PTR DNS record is created pointing from the IP address in the in-addr.arpa domain to the reverse FQDN.

Common.PublicIPAddressSku

SKU of a public IP address.

Name Type Description
name

PublicIPAddressSkuName

Name of a public IP address SKU.

tier

PublicIPAddressSkuTier

Tier of a public IP address SKU.

ResourceNavigationLink resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource navigation link identifier.

name

string

Name of the resource that is unique within a resource group. This name can be used to access the resource.

properties.link

string

Link to the external resource.

properties.linkedResourceType

string

Resource type of the linked resource.

properties.provisioningState

ProvisioningState

The provisioning state of the resource navigation link resource.

type

string

Resource type.

Common.RetentionPolicyParameters

Parameters that define the retention policy for flow log.

Name Type Default value Description
days

integer (int32)

0

Number of days to retain flow log records.

enabled

boolean

False

Flag to enable/disable retention.

Common.Route

Route resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.addressPrefix

string

The destination CIDR to which the route applies.

properties.hasBgpOverride

boolean

A value indicating whether this route overrides overlapping BGP routes regardless of LPM.

properties.nextHopIpAddress

string

The IP address packets should be forwarded to. Next hop values are only allowed in routes where the next hop type is VirtualAppliance.

properties.nextHopType

RouteNextHopType

The type of Azure hop the packet should be sent to.

properties.provisioningState

ProvisioningState

The provisioning state of the route resource.

type

string

Resource type.

Common.RouteTable

Route table resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.disableBgpRoutePropagation

boolean

Whether to disable the routes learned by BGP on that route table. True means disable.

properties.provisioningState

ProvisioningState

The provisioning state of the route table resource.

properties.resourceGuid

string

The resource GUID property of the route table.

properties.routes

Common.Route[]

Collection of routes contained within a route table.

properties.subnets

Common.Subnet[]

A collection of references to subnets.

tags

object

Resource tags.

type

string

Resource type.

Common.SecurityRule

Network security rule.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.access

SecurityRuleAccess

The network traffic is allowed or denied.

properties.description

string

A description for this rule. Restricted to 140 chars.

properties.destinationAddressPrefix

string

The destination address prefix. CIDR or destination IP range. Asterisk '*' can also be used to match all source IPs. Default tags such as 'VirtualNetwork', 'AzureLoadBalancer' and 'Internet' can also be used.

properties.destinationAddressPrefixes

string[]

The destination address prefixes. CIDR or destination IP ranges.

properties.destinationApplicationSecurityGroups

Common.ApplicationSecurityGroup[]

The application security group specified as destination.

properties.destinationPortRange

string

The destination port or range. Integer or range between 0 and 65535. Asterisk '*' can also be used to match all ports.

properties.destinationPortRanges

string[]

The destination port ranges.

properties.direction

SecurityRuleDirection

The direction of the rule. The direction specifies if rule will be evaluated on incoming or outgoing traffic.

properties.priority

integer (int32)

The priority of the rule. The value can be between 100 and 4096. The priority number must be unique for each rule in the collection. The lower the priority number, the higher the priority of the rule.

properties.protocol

SecurityRuleProtocol

Network protocol this rule applies to.

properties.provisioningState

ProvisioningState

The provisioning state of the security rule resource.

properties.sourceAddressPrefix

string

The CIDR or source IP range. Asterisk '*' can also be used to match all source IPs. Default tags such as 'VirtualNetwork', 'AzureLoadBalancer' and 'Internet' can also be used. If this is an ingress rule, specifies where network traffic originates from.

properties.sourceAddressPrefixes

string[]

The CIDR or source IP ranges.

properties.sourceApplicationSecurityGroups

Common.ApplicationSecurityGroup[]

The application security group specified as source.

properties.sourcePortRange

string

The source port or range. Integer or range between 0 and 65535. Asterisk '*' can also be used to match all ports.

properties.sourcePortRanges

string[]

The source port ranges.

type

string

Resource type.

ServiceAssociationLink resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource that is unique within a resource group. This name can be used to access the resource.

properties.allowDelete

boolean

If true, the resource can be deleted.

properties.link

string

Link to the external resource.

properties.linkedResourceType

string

Resource type of the linked resource.

properties.locations

string[]

A list of locations.

properties.provisioningState

ProvisioningState

The provisioning state of the service association link resource.

type

string

Resource type.

Common.ServiceEndpointPolicy

Service End point policy resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

kind

string

Kind of service endpoint policy. This is metadata used for the Azure portal experience.

location

string

Resource location.

name

string

Resource name.

properties.contextualServiceEndpointPolicies

string[]

A collection of contextual service endpoint policy.

properties.provisioningState

ProvisioningState

The provisioning state of the service endpoint policy resource.

properties.resourceGuid

string

The resource GUID property of the service endpoint policy resource.

properties.serviceAlias

string

The alias indicating if the policy belongs to a service

properties.serviceEndpointPolicyDefinitions

Common.ServiceEndpointPolicyDefinition[]

A collection of service endpoint policy definitions of the service endpoint policy.

properties.subnets

Common.Subnet[]

A collection of references to subnets.

tags

object

Resource tags.

type

string

Resource type.

Common.ServiceEndpointPolicyDefinition

Service Endpoint policy definitions.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.description

string

A description for this rule. Restricted to 140 chars.

properties.provisioningState

ProvisioningState

The provisioning state of the service endpoint policy definition resource.

properties.service

string

Service endpoint name.

properties.serviceResources

string[]

A list of service resources.

type

string

Resource type.

Common.ServiceEndpointPropertiesFormat

The service endpoint properties.

Name Type Description
locations

string[]

A list of locations.

networkIdentifier

Common.SubResource

SubResource as network identifier.

provisioningState

ProvisioningState

The provisioning state of the service endpoint resource.

service

string

The type of the endpoint service.

Common.Subnet

Subnet in a virtual network resource.

Name Type Default value Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.addressPrefix

string

The address prefix for the subnet.

properties.addressPrefixes

string[]

List of address prefixes for the subnet.

properties.applicationGatewayIPConfigurations

Common.ApplicationGatewayIPConfiguration[]

Application gateway IP configurations of virtual network resource.

properties.defaultOutboundAccess

boolean

Set this property to false to disable default outbound connectivity for all VMs in the subnet.

properties.delegations

Common.Delegation[]

An array of references to the delegations on the subnet.

properties.ipAllocations

Common.SubResource[]

Array of IpAllocation which reference this subnet.

properties.ipConfigurationProfiles

Common.IPConfigurationProfile[]

Array of IP configuration profiles which reference this subnet.

properties.ipConfigurations

Common.IPConfiguration[]

An array of references to the network interface IP configurations using subnet.

properties.ipamPoolPrefixAllocations

Common.IpamPoolPrefixAllocation[]

A list of IPAM Pools for allocating IP address prefixes.

properties.natGateway

Common.SubResource

Nat gateway associated with this subnet.

properties.networkSecurityGroup

Common.NetworkSecurityGroup

The reference to the NetworkSecurityGroup resource.

properties.privateEndpointNetworkPolicies

VirtualNetworkPrivateEndpointNetworkPolicies

Disabled

Enable or Disable apply network policies on private end point in the subnet.

properties.privateEndpoints

Common.PrivateEndpoint[]

An array of references to private endpoints.

properties.privateLinkServiceNetworkPolicies

VirtualNetworkPrivateLinkServiceNetworkPolicies

Enabled

Enable or Disable apply network policies on private link service in the subnet.

properties.provisioningState

ProvisioningState

The provisioning state of the subnet resource.

properties.purpose

string

A read-only string identifying the intention of use for this subnet based on delegations and other user-defined properties.

properties.resourceNavigationLinks

Common.ResourceNavigationLink[]

An array of references to the external resources using subnet.

properties.routeTable

Common.RouteTable

The reference to the RouteTable resource.

properties.serviceAssociationLinks

Common.ServiceAssociationLink[]

An array of references to services injecting into this subnet.

properties.serviceEndpointPolicies

Common.ServiceEndpointPolicy[]

An array of service endpoint policies.

properties.serviceEndpoints

Common.ServiceEndpointPropertiesFormat[]

An array of service endpoints.

properties.serviceGateway

Common.SubResource

Reference to an existing service gateway.

properties.sharingScope

SharingScope

Set this property to Tenant to allow sharing subnet with other subscriptions in your AAD tenant. This property can only be set if defaultOutboundAccess is set to false, both properties can only be set if subnet is empty.

type

string

Resource type.

Common.SubResource

Reference to another subresource.

Name Type Description
id

string

Resource ID.

Common.TrafficAnalyticsConfigurationProperties

Parameters that define the configuration of traffic analytics.

Name Type Description
enabled

boolean

Flag to enable/disable traffic analytics.

trafficAnalyticsInterval

integer (int32)

The interval in minutes which would decide how frequently TA service should do flow analytics.

workspaceId

string

The resource guid of the attached workspace.

workspaceRegion

string

The location of the attached workspace.

workspaceResourceId

string

Resource Id of the attached workspace.

Common.TrafficAnalyticsProperties

Parameters that define the configuration of traffic analytics.

Name Type Description
networkWatcherFlowAnalyticsConfiguration

Common.TrafficAnalyticsConfigurationProperties

Parameters that define the configuration of traffic analytics.

Common.VirtualNetworkTap

Virtual Network Tap resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.destinationLoadBalancerFrontEndIPConfiguration

Common.FrontendIPConfiguration

The reference to the private IP address on the internal Load Balancer that will receive the tap.

properties.destinationNetworkInterfaceIPConfiguration

Common.NetworkInterfaceIPConfiguration

The reference to the private IP Address of the collector nic that will receive the tap.

properties.destinationPort

integer (int32)

The VXLAN destination port that will receive the tapped traffic.

properties.networkInterfaceTapConfigurations

Common.NetworkInterfaceTapConfiguration[]

Specifies the list of resource IDs for the network interface IP configuration that needs to be tapped.

properties.provisioningState

ProvisioningState

The provisioning state of the virtual network tap resource.

properties.resourceGuid

string

The resource GUID property of the virtual network tap resource.

tags

object

Resource tags.

type

string

Resource type.

DdosSettingsProtectionMode

The DDoS protection mode of the public IP

Value Description
VirtualNetworkInherited

VirtualNetworkInherited

Enabled

Enabled

Disabled

Disabled

DeleteOptions

Specify what happens to the public IP address when the VM using it is deleted

Value Description
Delete

Delete

Detach

Detach

ExtendedLocationTypes

The type of the extended location.

Value Description
EdgeZone

EdgeZone

FlowLogFormatType

The file type of flow log.

Value Description
JSON

JSON

GatewayLoadBalancerTunnelInterfaceType

Traffic type of gateway load balancer tunnel interface.

Value Description
None

None

Internal

Internal

External

External

GatewayLoadBalancerTunnelProtocol

Protocol of gateway load balancer tunnel interface.

Value Description
None

None

Native

Native

VXLAN

VXLAN

IPAllocationMethod

Private IP allocation method.

Value Description
Static

Static

Dynamic

Dynamic

IPVersion

Whether the specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4.

Value Description
IPv4

IPv4

IPv6

IPv6

LoadBalancerBackendAddressAdminState

A list of administrative states which once set can override health probe so that Load Balancer will always forward new connections to backend, or deny new connections and reset existing connections.

Value Description
None

None

Up

Up

Down

Down

ManagedServiceIdentityUserAssignedIdentities

Name Type Description
clientId

string

The client id of user assigned identity.

principalId

string

The principal id of user assigned identity.

NatGatewaySkuName

Name of Nat Gateway SKU.

Value Description
Standard

Standard

StandardV2

StandardV2

NetworkInterfaceAuxiliaryMode

Auxiliary mode of Network Interface resource.

Value Description
None

None

MaxConnections

MaxConnections

Floating

Floating

AcceleratedConnections

AcceleratedConnections

NetworkInterfaceAuxiliarySku

Auxiliary sku of Network Interface resource.

Value Description
None

None

A1

A1

A2

A2

A4

A4

A8

A8

NetworkInterfaceMigrationPhase

Migration phase of Network Interface resource.

Value Description
None

None

Prepare

Prepare

Commit

Commit

Abort

Abort

Committed

Committed

NetworkInterfaceNicType

Type of Network Interface resource.

Value Description
Standard

Standard

Elastic

Elastic

PrivateEndpointIPVersionType

Specifies the IP version type for the private IPs of the private endpoint. If not defined, this defaults to IPv4.

Value Description
IPv4

Indicates that the Private IPs of the private endpoint will be IPv4 only.

IPv6

Indicates that the Private IPs of the private endpoint will be IPv6 only.

DualStack

Indicates that the Private IPs of the private endpoint can be both IPv4 and IPv6.

ProvisioningState

The provisioning state of the application security group resource.

Value Description
Failed

Failed

Succeeded

Succeeded

Canceled

Canceled

Creating

Creating

Updating

Updating

Deleting

Deleting

PublicIpAddressDnsSettingsDomainNameLabelScope

The domain name label scope. If a domain name label and a domain name label scope are specified, an A DNS record is created for the public IP in the Microsoft Azure DNS system with a hashed value includes in FQDN.

Value Description
TenantReuse

TenantReuse

SubscriptionReuse

SubscriptionReuse

ResourceGroupReuse

ResourceGroupReuse

NoReuse

NoReuse

PublicIPAddressMigrationPhase

Migration phase of Public IP Address.

Value Description
None

None

Prepare

Prepare

Commit

Commit

Abort

Abort

Committed

Committed

PublicIPAddressSkuName

Name of a public IP address SKU.

Value Description
Basic

Basic

Standard

Standard

StandardV2

StandardV2

PublicIPAddressSkuTier

Tier of a public IP address SKU.

Value Description
Regional

Regional

Global

Global

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the virtual machine.

Value Description
SystemAssigned

SystemAssigned

UserAssigned

UserAssigned

SystemAssigned, UserAssigned

SystemAssigned, UserAssigned

None

None

RouteNextHopType

The type of Azure hop the packet should be sent to.

Value Description
VirtualNetworkGateway

VirtualNetworkGateway

VnetLocal

VnetLocal

Internet

Internet

VirtualAppliance

VirtualAppliance

None

None

SecurityRuleAccess

The network traffic is allowed or denied.

Value Description
Allow

Allow

Deny

Deny

SecurityRuleDirection

The direction of the rule. The direction specifies if rule will be evaluated on incoming or outgoing traffic.

Value Description
Inbound

Inbound

Outbound

Outbound

SecurityRuleProtocol

Network protocol this rule applies to.

Value Description
Tcp

Tcp

Udp

Udp

Icmp

Icmp

Esp

Esp

*
Ah

Ah

SharingScope

Set this property to Tenant to allow sharing subnet with other subscriptions in your AAD tenant. This property can only be set if defaultOutboundAccess is set to false, both properties can only be set if subnet is empty.

Value Description
Tenant

Tenant

DelegatedServices

DelegatedServices

SyncMode

Backend address synchronous mode for the backend pool

Value Description
Automatic

Automatic

Manual

Manual

TransportProtocol

The reference to the transport protocol used by the load balancing rule.

Value Description
Udp

Udp

Tcp

Tcp

All

All

Quic

Quic

VirtualNetworkPrivateEndpointNetworkPolicies

Enable or Disable apply network policies on private end point in the subnet.

Value Description
Enabled

Enabled

Disabled

Disabled

NetworkSecurityGroupEnabled

NetworkSecurityGroupEnabled

RouteTableEnabled

RouteTableEnabled

VirtualNetworkPrivateLinkServiceNetworkPolicies

Enable or Disable apply network policies on private link service in the subnet.

Value Description
Enabled

Enabled

Disabled

Disabled